exercise_04_20: exercise_04_20.o Analysis.o | .gitignore
	g++ $^ -o $@

exercise_04_20.o: exercise_04_20.s
	g++ -c $^ -o $@

exercise_04_20.s: exercise_04_20.ii
	g++ -S $^ -o $@

exercise_04_20.ii: exercise_04_20.cpp
	g++ -E $^ -o $@

.gitignore:
	echo $^ > $@

Analysis.o: Analysis.s
	g++ -c $^ -o $@

Analysis.s: Analysis.ii
	g++ -S $^ -o $@

Analysis.ii: Analysis.cpp
	g++ -E $^ -o $@

Analysis.cpp: Analysis.hpp

exercise_04_20.cpp: Analysis.hpp

removes:
	rm *.ii *.s *.o exercise_04_20 .gitignore *.out
test: 
		./exercise_04_20  < test.in > test.out 
		diff test.out test.expected && echo PASSED || echo FAILED


